#include "GroupCullingScene.h"

#include "TestScene.h"
#include "TerminalObject.h"
#include "GroupObject.h"
#include "Torus.h"


void GroupCullingScene::Init ()
{
	RawObject * torus;
	torus = new Torus (1.0f, 4.0f, 16, 16);
	torus->SetColor (0.2f, 0.4f, 0.8f, 0.0f);

	GroupObject * old_group;
	GroupObject * new_group;
	TerminalObject * terminal;

	old_group = NULL;
	new_group = NULL;

	// create a group of 'moving' objects
	for (int index = 0; index < 5; index++)
	{
		old_group = new_group;

		terminal = new TerminalObject (torus);
		new_group = new GroupObject ();
		new_group->AddChild (terminal);
		new_group->position->StartPath (0, 0.0f, 20.0f, 0.0f, 20.0f, 0.0f, 20.0f);
		new_group->position->SetDuration (30000);
		new_group->position->SetGlobalTransition (PP_LINEAR, 0.0f);
		new_group->position->CompletePath (0.0f, 20.0f, 0.0f, 20.0f, 0.0f, 20.0f);

		if (old_group != NULL)
		{new_group->AddChild (old_group);}
	}

	new_group->CalculateRelativePositions ();
	AddObject (new_group);


	// set up camera
	camera = new Camera ();
	camera->SetAttributes (45, 1.333, 10.0, 200.0);
	camera->position->StartPath (0, 50.0f, 20.0f, 30.0f, 0.0f, 0.0f, 160.0f);
	camera->position->SetDuration (30000);
	camera->position->SetGlobalTransition (PP_LINEAR, 0.0f);
	camera->position->CompletePath (100.0f, 0.0f, 30.0f, 1080.0f, 0.0f, 120.0f);
}