#ifndef ICOSAHEDRON_
#define ICOSAHEDRON_

#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "RawObject.h"

/**
 * \brief A simple icosahedron.
 *
 * A simple Icosahedron that uses GLUT to draw itself.
 */ 
class Icosahedron: public RawObject
{
public:
	/**
	 * Constuctor: Brings the object into a consistent state.
	 *
	 * \param size					Size of the Icosahedron.
	 */
	Icosahedron (double size);

	/**
	 * Destuctor.
	 */
	~Icosahedron ();

	/**
	 * Implementation of the Draw routine. Draws an icosahedron using GLUT.
	 */
	void Draw ();

	/**
	 * Implementation of the GetBoundingRadius routine.
	 */
	double GetBoundingRadius ();

	/**
	 * Implementation of the GetBoundingBox routine.
	 */
	BoundingBox GetBoundingBox ();

private:
	/** Hide the default constructor. */
	Icosahedron ();

	/** Size of the icosahedron. */
	double size;

	/** 1/size. */
	double reciprocal_size;
};


#endif