#ifndef SIMPLE_ARROW_
#define SIMPLE_ARROW_

#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "RawObject.h"

/**
 * \brief A simple arrow like object.
 *
 * A simple arrow like object that has its tip at (0, 0, 0).
 */
class SimpleArrow: public RawObject
{
public:
	/**
	 * Constuctor: Brings the object into a consistent state.
	 *
	 * \param size					Size of the arrow.
	 */
	SimpleArrow (double size);

	/**
	 * Destructor.
	 */
	~SimpleArrow ();

	/**
	 * Implementation of the Draw routine.
	 */
	void Draw ();

	/**
	 * Implementation of the GetBoundingRadius routine.
	 */
	double GetBoundingRadius ();

	/**
	 * Implementation of the GetBoundingBox routine.
	 */
	BoundingBox GetBoundingBox ();

private:
	/** Hide the default constructor. */
	SimpleArrow ();

	/** Size of the arrow. */
	double size;
};


#endif